package main;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.*;

import org.apache.commons.math3.linear.*;
import org.apache.commons.math3.stat.correlation.Covariance;

import kmeans.KMmain;
public class run {



	
	public static void main(String[] args) throws Exception {
		Paint.initialize(6);
		java.util.Locale.setDefault(Locale.ENGLISH);

		
		String[] sets = {"4 iris","7 vertebral column_3C","7 seeds", "8 wifi_localization", "9 breast-cancer-wisconsin","10 BreastTissue","13 wine"};
		String[] run = {"runEx"};
		
		//Execute PCE on the Running example (with Plots). We show it here with a fixed initialisation. Can easily be changed to random initialisation
		DipKM.runTheRunningExample();
		
		//Executing PCE on the real-world data sets. Since PCE is not deterministic due to the initialisation, we simlpy loaded the k-means labels from the respective folder and execute PCE with those as starting configuration. 
		//This shows the effect of PCE. As before, if one wants to start with a random initialisation, one can simply decomment one line there. PCE is executed 100 times
		//DipKM.runthemAll(sets);
		
		//Rerun the saved NMI-Labels for the Main-experiments. The labels are saved in the folder ./labels and we load them and compute the NMI for them.
		//The order is the same as for table 1. Keep in mind that AAA stands for PCE.
		
		//DipKM.RecomputeNMI(sets);	
		//DipKM.RecomputeNMIrunningExample("runEx");

		
		//Rerun NMI for the transformed data sets with the comparison methods
	
		//We admit, the following implementation is not completely userfriendly. Essentially, one has to de-comment e.g. BenUtil.EMResults(); to get the results for EM in Table 2
		//The same for the other methods. 
		
		//BenUtil.EMResults();
		//BenUtil.SingeLinkAAA();
		//BenUtil.SingeLink();
		//BenUtil.DBSCANResultsAAA();
		//BenUtil.DBSCANResultsOther();
		//BenUtil.SpectralResults();
		//BenUtil.KMPPResults();
		
		//The overview over all methods and datasets summed up
		//BenUtil.EMResultsTotal();
		//BenUtil.SingeLinkAAATotal();
		//BenUtil.SingeLinkTotal();
		//BenUtil.DBSCANResultsAAATotal();
		//BenUtil.DBSCANResultsOtherTotal();
		//BenUtil.SpectralResultsTotal();
		//BenUtil.KMPPResultsTotal();

		
	}

}
